import time
import subprocess

from board import SCL, SDA
import busio
from PIL import Image, ImageDraw, ImageFont
import adafruit_ssd1306


# Create the I2C interface.
i2c = busio.I2C(SCL, SDA)

# Create the SSD1306 OLED class.
# The first two parameters are the pixel width and pixel height.  Change these
# to the right size for your display!
disp = adafruit_ssd1306.SSD1306_I2C(128, 64, i2c)

# Clear display.
disp.fill(0)
disp.show()

# Create blank image for drawing.
# Make sure to create image with mode '1' for 1-bit color.
width = disp.width
height = disp.height
image = Image.new("1", (width, height))

# Get drawing object to draw on image.
draw = ImageDraw.Draw(image)

# Draw a black filled box to clear the image.
draw.rectangle((0, 0, width, height), outline=0, fill=0)

# Draw some shapes.
# First define some constants to allow easy resizing of shapes.
padding = -2
top = padding
bottom = height - padding
# Move left to right keeping track of the current x position for drawing shapes.
x = 0


# Load default font.
#font = ImageFont.load_default()

# Alternatively load a TTF font.  Make sure the .ttf font file is in the
# same directory as the python script!
# Some other nice fonts to try: http://www.dafont.com/bitmap.php
# font = ImageFont.truetype('/usr/share/fonts/truetype/dejavu/DejaVuSans.ttf', 9)
font = ImageFont.truetype('/usr/share/fonts/truetype/dejavu/DejaVuSans.ttf', 13)
#font = ImageFont.truetype('/usr/share/fonts/truetype/wqy/wqy-zenhei.ttc', 14, index=2)
font2 = ImageFont.truetype('/usr/share/fonts/truetype/dejavu/DejaVuSans.ttf', 22)

while True:
    # Draw a black filled box to clear the image.
    draw.rectangle((0, 0, width, height), outline=0, fill=0)

    # Shell scripts for system monitoring from here:
    # https://unix.stackexchange.com/questions/119126/command-to-display-memory-usage-disk-usage-and-cpu-load
    #cmd = "hostname -I | cut -d' ' -f1"
    #IP = subprocess.check_output(cmd, shell=True).decode("utf-8")
    #cmd = 'cut -f 1 -d " " /proc/loadavg'
    #CPU = subprocess.check_output(cmd, shell=True).decode("utf-8")
    #cmd = "free -m | awk 'NR==2{printf \"Mem: %s/%s MB  %.2f%%\", $3,$2,$3*100/$2 }'"
    #MemUsage = subprocess.check_output(cmd, shell=True).decode("utf-8")
    #cmd = 'df -h | awk \'$NF=="/"{printf "Disk: %d/%d GB  %s", $3,$2,$5}\''
    #Disk = subprocess.check_output(cmd, shell=True).decode("utf-8")

    cmd = "hostname -I | cut -d' ' -f1"
    IP = subprocess.check_output(cmd, shell=True).decode("utf-8")
    cmd = "top -bn2 -d 0.1 | grep %Cpu | awk 'NR==2{printf \"Load: %.2f%%\",100-$8}'"
    CPU = subprocess.check_output(cmd, shell = True ).decode("utf-8")
    cmd = "free -m | awk 'NR==2{printf \"Mem: %s/%sMB %.2f%%\", $3,$2,$3*1000/$2 }'"
    MemUsage = subprocess.check_output(cmd, shell = True ).decode("utf-8")
    cmd = "df -h | awk '$NF==\"/\"{printf \"Disk: %d/%dGB %s\", $3,$2,$5}'"
    Disk = subprocess.check_output(cmd, shell = True ).decode("utf-8")
    #cmd = "date | awk '{printf \"%s %s %s %s \", $1,$2,$3,$4}'"
    #date = subprocess.check_output(cmd, shell = True ).decode("utf-8")
    now_date = time.strftime("%Y-%m-%d")
    now_time = time.strftime("%H:%M:%S")
    cmd = "cat /sys/class/thermal/thermal_zone0/temp | awk '{printf \"%.1f\", $0/1000}'"
    cput = subprocess.check_output(cmd, shell= True).decode("utf-8")

    # Write four lines of text.

    #draw.text((x, top + 0), "IP: " + IP, font=font, fill=255)
    #draw.text((x, top + 8), "CPU load: " + CPU, font=font, fill=255)
    #draw.text((x, top + 16), MemUsage, font=font, fill=255)
    #draw.text((x, top + 25), Disk, font=font, fill=255)

    draw.text((x, top + 1),       "IP " + str(IP),  font=font, fill=255)
    draw.text((x, top + 15),     str(CPU), font=font, fill=255)
    draw.text((x + 90, top + 15),  str(cput),font=font, fill=255)
    #draw.text((x, top + 33),    str(MemUsage),  font=font, fill=255)
    draw.text((x, top + 29),    "Date: " + now_date,  font=font, fill=255)
    #draw.text((x, top+49),    str(Disk),  font=font, fill=255)
    #draw.text((x, top+34),    "temperature: " + str(temperature),font=font,fill=255)
    #draw.text((x, top+43),    "humidity: " + str(humidity),font=font,fill=255)
    draw.text((x, top + 45),    str(now_time),  font=font2, fill=255)

    # Display image.
    disp.image(image)
    disp.show()
    time.sleep(.1)